/*
 * Product Ordering
 *
 * **TMF API Reference : TMF 622 - Product Ordering Management**  **Release : 19.0 - June 2019**  The Product Ordering API provides a standardized mechanism for placing a product order with all of the necessary order parameters. The API consists of a simple set of operations that interact with CRM/Order Negotiation systems in a consistent manner. A product order is created based on a product offer that is defined in a catalog. The product offer identifies the product or set of products that are available to a customer, and includes characteristics such as pricing, product options and market. This API provide a task based resource to request order cancellation.  The product order references the product offer and identifies any specific requests made by the customer.  **Product Order resource** A Product Order is a type of order which can be used to place an order between a customer and a service provider or between a service provider and a partner and vice versa. Main Product Order attributes are its identifier, state, priority category (mass market, Enterprise, etc.) related dates (start, completion, etc.), related billing account, related parties and order items. Main Order Items (aka order lines) attributes are the ordered offering and product characteristics with the related action to be performed (e.g. add or delete the products), state, location information for delivery, order item price and price alteration.  Product Order API performs the following operations on product order :     -Retrieval of a product order or a collection of product orders depending on filter criteria     -Partial update of a product order (including updating rules)    -Creation of a product order (including default values and creation rules)    -Deletion of product order (for administration purposes)     -Notification of events on product order.  **cancelProductOrder resource** This resource is used to request a product order cancellation. Product Order API performs the following operations on product order :     -Retrieval of a cancel product order or a collection of cancel product orders     -Creation of a cancel product order     -Notification of events on cancel product order.   Copyright © TM Forum 2019. All Rights Reserved   
 *
 * API version: 4.0.0
 * Generated by: OpenAPI Generator (https://openapi-generator.tech)
 */

package openapi

import (
	"encoding/json"
	"net/http"
	"strings"

	"github.com/gorilla/mux"
)

// A NotificationListenersClientSideApiController binds http requests to an api service and writes the service results to the http response
type NotificationListenersClientSideApiController struct {
	service NotificationListenersClientSideApiServicer
}

// NewNotificationListenersClientSideApiController creates a default api controller
func NewNotificationListenersClientSideApiController(s NotificationListenersClientSideApiServicer) Router {
	return &NotificationListenersClientSideApiController{ service: s }
}

// Routes returns all of the api route for the NotificationListenersClientSideApiController
func (c *NotificationListenersClientSideApiController) Routes() Routes {
	return Routes{ 
		{
			"ListenToCancelProductOrderCreateEvent",
			strings.ToUpper("Post"),
			"/tmf-api/productOrderingManagement/v4/listener/cancelProductOrderCreateEvent",
			c.ListenToCancelProductOrderCreateEvent,
		},
		{
			"ListenToCancelProductOrderInformationRequiredEvent",
			strings.ToUpper("Post"),
			"/tmf-api/productOrderingManagement/v4/listener/cancelProductOrderInformationRequiredEvent",
			c.ListenToCancelProductOrderInformationRequiredEvent,
		},
		{
			"ListenToCancelProductOrderStateChangeEvent",
			strings.ToUpper("Post"),
			"/tmf-api/productOrderingManagement/v4/listener/cancelProductOrderStateChangeEvent",
			c.ListenToCancelProductOrderStateChangeEvent,
		},
		{
			"ListenToProductOrderAttributeValueChangeEvent",
			strings.ToUpper("Post"),
			"/tmf-api/productOrderingManagement/v4/listener/productOrderAttributeValueChangeEvent",
			c.ListenToProductOrderAttributeValueChangeEvent,
		},
		{
			"ListenToProductOrderCreateEvent",
			strings.ToUpper("Post"),
			"/tmf-api/productOrderingManagement/v4/listener/productOrderCreateEvent",
			c.ListenToProductOrderCreateEvent,
		},
		{
			"ListenToProductOrderDeleteEvent",
			strings.ToUpper("Post"),
			"/tmf-api/productOrderingManagement/v4/listener/productOrderDeleteEvent",
			c.ListenToProductOrderDeleteEvent,
		},
		{
			"ListenToProductOrderInformationRequiredEvent",
			strings.ToUpper("Post"),
			"/tmf-api/productOrderingManagement/v4/listener/productOrderInformationRequiredEvent",
			c.ListenToProductOrderInformationRequiredEvent,
		},
		{
			"ListenToProductOrderStateChangeEvent",
			strings.ToUpper("Post"),
			"/tmf-api/productOrderingManagement/v4/listener/productOrderStateChangeEvent",
			c.ListenToProductOrderStateChangeEvent,
		},
	}
}

// ListenToCancelProductOrderCreateEvent - Client listener for entity CancelProductOrderCreateEvent
func (c *NotificationListenersClientSideApiController) ListenToCancelProductOrderCreateEvent(w http.ResponseWriter, r *http.Request) { 
	data := &CancelProductOrderCreateEvent{}
	if err := json.NewDecoder(r.Body).Decode(&data); err != nil {
		w.WriteHeader(500)
		return
	}
	
	result, err := c.service.ListenToCancelProductOrderCreateEvent(r.Context(), *data)
	//If an error occured, encode the error with the status code
	if err != nil {
		EncodeJSONResponse(err.Error(), &result.Code, w)
		return
	}
	//If no error, encode the body and the result code
	EncodeJSONResponse(result.Body, &result.Code, w)
	
}

// ListenToCancelProductOrderInformationRequiredEvent - Client listener for entity CancelProductOrderInformationRequiredEvent
func (c *NotificationListenersClientSideApiController) ListenToCancelProductOrderInformationRequiredEvent(w http.ResponseWriter, r *http.Request) { 
	data := &CancelProductOrderInformationRequiredEvent{}
	if err := json.NewDecoder(r.Body).Decode(&data); err != nil {
		w.WriteHeader(500)
		return
	}
	
	result, err := c.service.ListenToCancelProductOrderInformationRequiredEvent(r.Context(), *data)
	//If an error occured, encode the error with the status code
	if err != nil {
		EncodeJSONResponse(err.Error(), &result.Code, w)
		return
	}
	//If no error, encode the body and the result code
	EncodeJSONResponse(result.Body, &result.Code, w)
	
}

// ListenToCancelProductOrderStateChangeEvent - Client listener for entity CancelProductOrderStateChangeEvent
func (c *NotificationListenersClientSideApiController) ListenToCancelProductOrderStateChangeEvent(w http.ResponseWriter, r *http.Request) { 
	data := &CancelProductOrderStateChangeEvent{}
	if err := json.NewDecoder(r.Body).Decode(&data); err != nil {
		w.WriteHeader(500)
		return
	}
	
	result, err := c.service.ListenToCancelProductOrderStateChangeEvent(r.Context(), *data)
	//If an error occured, encode the error with the status code
	if err != nil {
		EncodeJSONResponse(err.Error(), &result.Code, w)
		return
	}
	//If no error, encode the body and the result code
	EncodeJSONResponse(result.Body, &result.Code, w)
	
}

// ListenToProductOrderAttributeValueChangeEvent - Client listener for entity ProductOrderAttributeValueChangeEvent
func (c *NotificationListenersClientSideApiController) ListenToProductOrderAttributeValueChangeEvent(w http.ResponseWriter, r *http.Request) { 
	data := &ProductOrderAttributeValueChangeEvent{}
	if err := json.NewDecoder(r.Body).Decode(&data); err != nil {
		w.WriteHeader(500)
		return
	}
	
	result, err := c.service.ListenToProductOrderAttributeValueChangeEvent(r.Context(), *data)
	//If an error occured, encode the error with the status code
	if err != nil {
		EncodeJSONResponse(err.Error(), &result.Code, w)
		return
	}
	//If no error, encode the body and the result code
	EncodeJSONResponse(result.Body, &result.Code, w)
	
}

// ListenToProductOrderCreateEvent - Client listener for entity ProductOrderCreateEvent
func (c *NotificationListenersClientSideApiController) ListenToProductOrderCreateEvent(w http.ResponseWriter, r *http.Request) { 
	data := &ProductOrderCreateEvent{}
	if err := json.NewDecoder(r.Body).Decode(&data); err != nil {
		w.WriteHeader(500)
		return
	}
	
	result, err := c.service.ListenToProductOrderCreateEvent(r.Context(), *data)
	//If an error occured, encode the error with the status code
	if err != nil {
		EncodeJSONResponse(err.Error(), &result.Code, w)
		return
	}
	//If no error, encode the body and the result code
	EncodeJSONResponse(result.Body, &result.Code, w)
	
}

// ListenToProductOrderDeleteEvent - Client listener for entity ProductOrderDeleteEvent
func (c *NotificationListenersClientSideApiController) ListenToProductOrderDeleteEvent(w http.ResponseWriter, r *http.Request) { 
	data := &ProductOrderDeleteEvent{}
	if err := json.NewDecoder(r.Body).Decode(&data); err != nil {
		w.WriteHeader(500)
		return
	}
	
	result, err := c.service.ListenToProductOrderDeleteEvent(r.Context(), *data)
	//If an error occured, encode the error with the status code
	if err != nil {
		EncodeJSONResponse(err.Error(), &result.Code, w)
		return
	}
	//If no error, encode the body and the result code
	EncodeJSONResponse(result.Body, &result.Code, w)
	
}

// ListenToProductOrderInformationRequiredEvent - Client listener for entity ProductOrderInformationRequiredEvent
func (c *NotificationListenersClientSideApiController) ListenToProductOrderInformationRequiredEvent(w http.ResponseWriter, r *http.Request) { 
	data := &ProductOrderInformationRequiredEvent{}
	if err := json.NewDecoder(r.Body).Decode(&data); err != nil {
		w.WriteHeader(500)
		return
	}
	
	result, err := c.service.ListenToProductOrderInformationRequiredEvent(r.Context(), *data)
	//If an error occured, encode the error with the status code
	if err != nil {
		EncodeJSONResponse(err.Error(), &result.Code, w)
		return
	}
	//If no error, encode the body and the result code
	EncodeJSONResponse(result.Body, &result.Code, w)
	
}

// ListenToProductOrderStateChangeEvent - Client listener for entity ProductOrderStateChangeEvent
func (c *NotificationListenersClientSideApiController) ListenToProductOrderStateChangeEvent(w http.ResponseWriter, r *http.Request) { 
	data := &ProductOrderStateChangeEvent{}
	if err := json.NewDecoder(r.Body).Decode(&data); err != nil {
		w.WriteHeader(500)
		return
	}
	
	result, err := c.service.ListenToProductOrderStateChangeEvent(r.Context(), *data)
	//If an error occured, encode the error with the status code
	if err != nil {
		EncodeJSONResponse(err.Error(), &result.Code, w)
		return
	}
	//If no error, encode the body and the result code
	EncodeJSONResponse(result.Body, &result.Code, w)
	
}
